﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
#End Region

Sub globals
	
End Sub

Sub Process_Globals
	Private nid As Int = 1
	Private GPS As GPS
	Private Tracking As Boolean
	Private LastUpdateTime As Long
	Private lock As PhoneWakeState
	Public sql1 As SQL
End Sub

Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	GPS.Initialize("gps")
	lock.PartialLock
	sql1.Initialize (File.DirDefaultExternal, "mylocation.db", True)
	Private t As String
	t = "CREATE TABLE if not exists locations (ID INTEGER PRIMARY KEY, zeit integer, lati real, longi real, " & _
	"alti real, speed real, dist real)"
	sql1.ExecNonQuery (t)
	t = "create index if not exists zeit_index on locations (zeit)"
	sql1.ExecNonQuery (t)
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StartForeground(nid, CreateNotification("..."))
	StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerMinute, True)
	Track
End Sub

Public Sub Track
	If Tracking Then Return
	If Starter.rp.Check(Starter.rp.PERMISSION_ACCESS_FINE_LOCATION) = False Then
		Log("No permission")
		Return
	End If
	GPS.Start(0, 0)
	Tracking = True
End Sub

Sub GPS_LocationChanged (Location1 As Location)
	If DateTime.Now > LastUpdateTime + 10 * DateTime.TicksPerSecond Then
		Dim n As Notification = CreateNotification($"$2.5{Location1.Latitude} / $2.5{Location1.Longitude}"$)
		n.Notify(nid)
		LastUpdateTime = DateTime.Now
		
		sql1.ExecNonQuery ("insert into locations values (NULL, " & DateTime.now & "," & Location1.Latitude  & "," & Location1.Longitude & "," & Location1.Altitude & "," & Location1.speed & ",0)")
						
	End If
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "icon"
	notification.SetInfo("Tracking location", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	If Tracking Then
		GPS.Stop
	End If
	Tracking = False
	lock.ReleasePartialLock
End Sub
